' ********************************************************************************
' * Save user configuration 
' ********************************************************************************
Option Explicit

'===============================================================================
' Const declaration
'===============================================================================
Const K_FSO_FOR_WRITING = 2
Const OverWriteFiles = TRUE
Const SAVE_DEST_FOLDER = "\a4902save"

'===============================================================================
'Variable declaration
'===============================================================================
Dim WshShell
Dim objFso
dim objFolder

Dim strRegKey
Dim strAppName
Dim strAppPath
Dim strMyDocumentsPath
Dim strApplicationDataPath
Dim strSavePath
Dim strExecCommand

' objets creation
Set WshShell = Wscript.CreateObject("Wscript.Shell")
set objFso = CreateObject("Scripting.FileSystemObject")

' Get special folders
strMyDocumentsPath = WshShell.SpecialFolders("MyDocuments")
strApplicationDataPath = WshShell.SpecialFolders("AppData")


' Get Application installation parameters
'@BA@crms00295700@ssenthil@201100516@
' strRegKey = "HKLM\Software\Alcatel\4902\Install\" 
If RegistryKeyExists("SOFTWARE\Alcatel\4902\Install\") =True THEN
   strRegKey = "HKLM\Software\Alcatel\4902\Install\" 
ElseIf RegistryKeyExists("SOFTWARE\Wow6432Node\Alcatel\4902\Install\") =True THEN
   strRegKey = "HKLM\SOFTWARE\Wow6432Node\Alcatel\4902\Install\"
Else
   WScript.Echo  "Information missing. Cannot able to Restore."
   Wscript.Quit        
End If
'@EA@crms00295700@ssenthil@201100516@


strAppName = WshShell.regread(strRegKey & "4902Name")
strAppPath = WshShell.regread(strRegKey & "Path")

strApplicationDataPath = strApplicationDataPath & "\" & strAppName
strSavePath = strMyDocumentsPath & SAVE_DEST_FOLDER
'WScript.Echo strApplicationDataPath
'WScript.Echo strSavePath

' create application data folder
If not(objFso.FolderExists(strApplicationDataPath)) Then
	set objFolder = objFso.CreateFolder(strApplicationDataPath)
else 
	set objFolder = objFso.GetFolder(strApplicationDataPath)
end if

' restore registry keys
If objFso.FileExists(strSavePath & "\4902BkUp.reg") Then
	strExecCommand = "REG.exe IMPORT """ & strSavePath & "\4902BkUp.reg"""
	WshShell.run strExecCommand, 5, true
end if
If objFso.FileExists(strSavePath & "\UAsigBkUp.reg") Then
	strExecCommand = "REG.exe IMPORT """ & strSavePath & "\UAsigBkUp.reg"""
	WshShell.run strExecCommand, 5, true
end if
If objFso.FileExists(strSavePath & "\TSpiCstaBkUp.reg") Then
	strExecCommand = "REG.exe IMPORT """ & strSavePath & "\TSpiCstaBkUp.reg"""
	WshShell.run strExecCommand, 5, true
end if

' restore user profile files 
strSavePath = strSavePath & "\config"
If objFso.FolderExists(strSavePath) Then
	objFso.CopyFile strSavePath & "\*", strApplicationDataPath & "\", OverWriteFiles
	objFso.CopyFolder strSavePath & "\*", strApplicationDataPath & "\", OverWriteFiles
end if

WScript.Echo "Configuration restored."

 '@BA@crms00295700@ssenthil@201100516@
Function RegistryKeyExists(strKey) 
  Set WshShell = WScript.CreateObject("WScript.Shell") 
  On Error Resume Next 
  WSHShell.RegRead "HKLM\" & strKey
  If Err.Number<>0 Then 
	Err.Clear 
    RegistryKeyExists=False 
  Else 
	RegistryKeyExists=True 
  End If 
 On Error GoTo 0  
End Function
 '@EA@crms00295700@ssenthil@201100516@