VERSION 5.00
Begin VB.Form fParam 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "Contact"
   ClientHeight    =   2415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3240
   Enabled         =   0   'False
   LinkTopic       =   "Form1"
   ScaleHeight     =   2415
   ScaleWidth      =   3240
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
End
Attribute VB_Name = "fParam"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
' This form is used to launch Access and show the contact corresponding to
' the contactID given in parameter. Access path and database path are also
' given in parameters to the command.
' Command line under form : ShowContact "access path" "database path" "contactID"
' ------------------------------------------------------------------------------

Option Explicit

Private objAccess As Object         'reference to Access object (with database)

'----------------------------------------------------------------------
'called when form is loaded (entry point)
'retrieve parameters on command line and show the contact
'----------------------------------------------------------------------
Private Sub Form_Load()

Dim CmdLine() As String         'command line splitted
Dim accpath As String           'path of Access application
Dim dbpath As String            'path of Access database used
Dim ID As String                'Contact ID

On Error GoTo Herr

'init
    accpath = ""
    dbpath = ""
    ID = ""

'parse the command line of the program to retrieve the parameters
    CmdLine = Split(Command, """")
    If UBound(CmdLine) > 5 Then
        accpath = CmdLine(1)
        dbpath = CmdLine(3)
        ID = CmdLine(5)
    End If
    
'if parameters OK, open access and contact...
    If Len(accpath) <> 0 And Len(dbpath) <> 0 And Len(ID) <> 0 Then
        OpenContact accpath, dbpath, ID
    Else
        GoTo Herr
    End If
    
    End
    Exit Sub

Herr:
    MsgBox "Error " & Err.Description & " in " & Err.Source & " Command line = " & Command
    End
End Sub

'----------------------------------------------------------------------
'Launch Access (if not already done) with path specified in 'accpath',
'get a reference on Access object with database corresponding to 'dbpath'
'and Open the form contact with contact referenced by 'contactID'.
'----------------------------------------------------------------------

Private Sub OpenContact(accpath As String, dbpath As String, contactID As String)

On Error GoTo Herr

'get reference on Access object with right database
    Set objAccess = GetObject(dbpath)
    If Err <> 0 Then
      If Dir(dbpath) = "" Then          'dbpath is not valid
        MsgBox "Error : Couldn't find database " & dbpath
        Exit Sub
      Else          'The full version of Microsoft Access is not installed.
        If Dir(accpath) = "" Then
           MsgBox "Error : Couldn't find Microsoft Access " & accpath
           Exit Sub
        Else
        'launch instance of Access application
           Shell accpath & " " & Chr(34) & dbpath & Chr(34), 6
           Do   'Wait for shelled process to finish
             Err = 0
             Set objAccess = GetObject(dbpath)
           Loop While Err <> 0
        End If
      End If
   End If
  
'show Access Window
  ShowAccess objAccess, SW_SHOW
  
' open form Contacts (with contactID)
  objAccess.DoCmd.OpenForm "Contacts", acNormal, "", "[Contacts]![ContactID]=" & contactID, , acNormal
   
  Exit Sub

Herr:
    MsgBox "Error " & Err.Description & " In " & Err.Source
End Sub

'----------------------------------------------------------------------
'This procedure brings the instance of Microsoft Access referred to
'as "instance" into view. The instance's window size can be SW_NORMAL,
'SW_MINIMIZE, SW_MAXIMIZE, or SW_SHOW. If size is omitted, the window is
'not changed (SW_SHOW). To call this function, use this syntax:
'   ShowAccess instance:=objAccess, size:=SW_SHOW
'----------------------------------------------------------------------

Sub ShowAccess(instance As Object, Optional size As Variant)
Dim hWnd As Long, temp As Long

  If IsMissing(size) Then size = SW_SHOW
  On Error Resume Next
      If Not instance.UserControl Then instance.Visible = True
      On Error GoTo 0       'turn off error handler
      hWnd = instance.hWndAccessApp
      temp = SetForegroundWindow(hWnd)
      If size = SW_SHOW Then    'keep current window size
           If IsIconic(hWnd) Then temp = ShowWindow(hWnd, SW_SHOW)
      Else
           If IsIconic(hWnd) And size = SW_MAXIMIZE Then _
             temp = ShowWindow(hWnd, SW_NORMAL)
           temp = ShowWindow(hWnd, size)
      End If
End Sub

