<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
<xsl:output 
  method="html"
  version="1.0"
  media-type="text/html; charset=UTF-8"
  encoding="UTF-8"
  doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"
  doctype-system="http://www.w3.org/TR/html4/loose.dtd"
  indent="yes" />
	<xsl:template match="/">
			<html>
					<head>
						<style type="text/css" >
							<!-- CSS style -->
							<!--links-->
			A:visited { COLOR: #000000; TEXT-DECORATION: none }
			A:link { COLOR: #000000; TEXT-DECORATION: none }
			A:active { COLOR: #000000; TEXT-DECORATION: none }
			A:hover { COLOR: GRAY; TEXT-DECORATION: underline }
			<!--module-->
			.module { font-weight:bold; font-family:verdana; font-size:10pt; }
			<!--test-->
			.test {	font-weight:bold; font-family:verdana; font-size:9pt }
			<!--info name-->
			.infoname { font-weight:bold; font-family:verdana; font-size:8pt }
			<!--info value-->
			.infovalue { font-weight:bold; font-family:verdana; font-size:8pt }
			<!-- info-ok -->
			.info-ok { position:relative; top:0px; border: 1px solid #333; width:800px; }
			<!-- info-nok -->
			.info-nok { position:relative; top:0px; border: 1px solid #333; width:800px; }
			<!-- device -->
			.device { position:relative; top:0px; border: 1px solid #333; width:800px; }
			<!-- error -->
			.error { position:relative; top:0px; border: 1px solid #333; width:800px; }
		</style>
						<title>Phone Application Diagnostic Report</title>
						<script  type="text/javascript">
					<![CDATA[
							
			ie = (document.all)? true:false;
			ns = (document.layers)? true:false;
			
			// Show/Hide functions for pointer objects
			function showHideObject(module, status)
			{			
				if (document.getElementById)
				{
					var obj = document.getElementById(module);
					if( status == 'visible' )
					{
						obj.style.visibility = 'visible';
						obj.style.display = '';					
					}
					else if( status == 'hide' )
					{
						obj.style.visibility = 'hidden';
						obj.style.display = 'none';					
					}
					else if (obj.style.visibility == 'visible')
					{
						obj.style.visibility = 'hidden';
						obj.style.display = 'none';
					}
					else
					{
						obj.style.visibility = 'visible';
						obj.style.display = '';
					}				
				}
			}
			
			function searchSubModule(module, status)
			{
				if( module != "" )
				{
					if( document.getElementById)
					{
						if(  document.getElementById(module) )
						{
							showHideObject(module, status);												 
							 if (!status)
							 {
							 	if( document.getElementById(module).style.visibility == 'visible' )
							 	{
							 		status = 'visible';
							 	}
							 	else
							 	{
							 		status = 'hide';
							 	}
							 }
							searchSubDiv(  document.getElementById(module)  , status);
						}
					}
				}
				else
				{
					searchSubDiv(  document.getElementById('mastermodule').parentNode  );
				}
			}
			
			function searchSubDiv(node, status)
			{
				if( node)
				{
					var obj =node.childNodes;
					var i;
					for(i= 0; i < obj.length; i++)
					{
						if( obj[i].nodeName == "DIV" )
						{
							if( obj[i].getAttribute('id') )
							{
								searchSubModule(obj[i].getAttribute('id'), status);
							}
							else
							{
								searchSubDiv( obj[i] ,status);
							}
						}
					}	
				}		
			}	
			
	]]>						</script>
					</head>
					<!-- page title -->
					<body bgcolor="#F5F5ED">
					<div style="text-align: center;">
						<font face="verdana" size="5">Phone Application Diagnostic Report</font>
						</div>
						<hr WIDTH="100%"/>
						<!-- the liste of modules names -->
						<xsl:for-each select="/report">
							<a>
								<xsl:attribute name="href"><xsl:text>javascript:searchSubModule('');</xsl:text></xsl:attribute>
								<xsl:attribute name="id"><xsl:text>mastermodule</xsl:text></xsl:attribute>
								<xsl:text>[+]</xsl:text>
							</a>
							<xsl:apply-templates select="module"/>
						</xsl:for-each>
					</body>
				</html>
	</xsl:template>
	<!-- **************************** MODULE *********************************-->
	<xsl:template match="module">
		<div style="position:relative; top:auto; visibility:visible;">
			<table width="100%" bgcolor="#EDEDDD">
				<tr>
				      <td  width="2%">
						<a>
							<xsl:attribute name="href"><xsl:text>javascript:searchSubModule('module</xsl:text><xsl:value-of select="position()"/><xsl:text>');</xsl:text></xsl:attribute>
							<xsl:text>[+]</xsl:text>
						</a>
    				 	</td>
					<td>
						<b>
							<a>
								<xsl:attribute name="href"><xsl:text>javascript:showHideObject('module</xsl:text><xsl:value-of select="position()"/><xsl:text>');</xsl:text></xsl:attribute>
								<xsl:attribute name="class"><xsl:text>module</xsl:text></xsl:attribute>
								<xsl:if test="test/@result='NOK'">
									<xsl:attribute name="style"><xsl:text>color: rgb(255,0,0);</xsl:text></xsl:attribute>
								</xsl:if>
								<xsl:text>Module : </xsl:text>
								<xsl:value-of select="@name"/>
							</a>
						</b>
					</td>
					<xsl:if test="test/@result='NOK'">
						<td width="10%">
							<a class="module" style="color: rgb(255,0,0);">
								<xsl:text>NOK</xsl:text>
							</a>
						</td>
					</xsl:if>					
					<xsl:if test="count(error) > 0">
						<td width="10%">
							<a class="module" style="color: rgb(255,0,0);">
								<xsl:text>Error</xsl:text>
							</a>
						</td>
					</xsl:if>					
				</tr>
			</table>
			<div style="position:relative; top:auto; visibility:hidden; display:none">
				<xsl:attribute name="id"><xsl:text>module</xsl:text><xsl:value-of select="position()"/></xsl:attribute>
				<xsl:apply-templates select="test"/>
				<xsl:apply-templates select="error"/>
			</div>
		</div>
	</xsl:template>
	<!-- **************************** TEST ************************************-->
	<xsl:template match="test">
		<div style="position:relative; top:auto; visibility:visible; left:20px;">
			<table width="100%" bgcolor="#D5EBEB">
				<tr>
				      <td  width="2%">
						<a>
								<xsl:if test="count(child::*) > 0">
									<xsl:attribute name="href"><xsl:text>javascript:showHideObject('module</xsl:text><xsl:value-of select="count(../preceding-sibling::*)+1"/><xsl:text>test</xsl:text><xsl:value-of select="position()"/><xsl:text>');</xsl:text></xsl:attribute>
									<xsl:text>[+]</xsl:text>
								</xsl:if>
						</a>
    				 	</td>
					<td>
						<b>
							<a>
								<xsl:if test="count(child::*) > 0">
									<xsl:attribute name="href"><xsl:text>javascript:showHideObject('module</xsl:text><xsl:value-of select="count(../preceding-sibling::*)+1"/><xsl:text>test</xsl:text><xsl:value-of select="position()"/><xsl:text>');</xsl:text></xsl:attribute>
								</xsl:if>
								<xsl:attribute name="class"><xsl:text>module</xsl:text></xsl:attribute>
								<xsl:if test="@result='NOK'">
									<xsl:attribute name="style"><xsl:text>color: rgb(255,0,0);</xsl:text></xsl:attribute>
								</xsl:if>
								<xsl:text>Test : </xsl:text>
								<xsl:value-of select="@name"/>
							</a>
						</b>
					</td>
					<td width="10%">
						<xsl:if test="not(@result='NOK')">
							<a class="module">
								<xsl:value-of select="@result"/>
							</a>
						</xsl:if>
						<xsl:if test="@result='NOK'">
							<a class="module" style="color: rgb(255,0,0);">
								<xsl:value-of select="@result"/>
							</a>
						</xsl:if>
					</td>
				</tr>
			</table>
			<xsl:if test="count(*)>0">
				<div style="position:relative; top:0px; visibility:hidden; display:none; left:20px;">
					<xsl:attribute name="id"><xsl:text>module</xsl:text><xsl:value-of select="count(../preceding-sibling::*)+1"/><xsl:text>test</xsl:text><xsl:value-of select="position()"/></xsl:attribute>
					<xsl:apply-templates select="info-group"/>
					<xsl:apply-templates select="Device"/>
					<xsl:apply-templates select="error"/>
					<xsl:if test="count(info[@name])>0">
						<div class="info-ok">
							<table width="100%" bgcolor="#E5E5E5">
								<xsl:apply-templates select="info"/>
							</table>
						</div>
					</xsl:if>
				</div>
			</xsl:if>
		</div>
	</xsl:template>
	<!-- **************************** DEVICE ******************************-->
	<xsl:template match="Device">
		<xsl:if test="position() mod 2 = 0">
			<div class="device">
				<table width="100%" bgcolor="#F5F5F5">
					<tr>
						<td width="30%">
							<font class="infovalue">Device Type</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="@type"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Name</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./UserName/Name"/>
								<xsl:text>  </xsl:text>
								<xsl:value-of select="./UserName/FirstName"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Device Number</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./Number"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Device Status</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./Status"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Device Internal ID</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./InternalID"/>
							</font>
						</td>
					</tr>
				</table>
			</div>
		</xsl:if>
		<xsl:if test="position() mod 2 != 0">
			<div class="device">
				<table width="100%" bgcolor="#E5E5E5">
					<tr>
						<td width="30%">
							<font class="infovalue">Device Type</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="@type"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Name</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./UserName/Name"/>
								<xsl:text>  </xsl:text>
								<xsl:value-of select="./UserName/FirstName"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Device Number</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./Number"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Device Status</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./Status"/>
							</font>
						</td>
					</tr>
					<tr>
						<td width="30%">
							<font class="infovalue">Device Internal ID</font>
						</td>
						<td width="50%">
							<font class="infoname">
								<xsl:value-of select="./InternalID"/>
							</font>
						</td>
					</tr>
				</table>
			</div>
		</xsl:if>
	</xsl:template>
	<!-- **************************** INFO GROUP ******************************-->
	<xsl:template match="info-group">
		<xsl:if test="count(info[@name])>0">
			<!--RED LINES-->
			<xsl:if test="info[@name='Exist' and @value='no']">
				<xsl:if test="position() mod 2 = 0">
					<div class="info-ok">
						<table width="100%" bgcolor="#FFBBBB">
							<xsl:apply-templates select="info"/>
						</table>
					</div>
				</xsl:if>
				<xsl:if test="position() mod 2 != 0">
					<div class="info-ok">
						<table width="100%" bgcolor="#EEAAAA">
							<xsl:apply-templates select="info"/>
						</table>
					</div>
				</xsl:if>
			</xsl:if>
			<!--NORMAL LINES-->
			<xsl:if test="not(info[@name='Exist' and @value='no'])">
			<!--RED LINES for file not up to date -->
				<xsl:if test="info[@name='Comment' and @value='The file is NOT up to date']">
					<xsl:if test="position() mod 2 = 0">
						<div class="info-ok">
							<table width="100%" bgcolor="#FFBBBB">
								<xsl:apply-templates select="info"/>
							</table>
						</div>
					</xsl:if>
					<xsl:if test="position() mod 2 != 0">
						<div class="info-ok">
							<table width="100%" bgcolor="#EEAAAA">
								<xsl:apply-templates select="info"/>
							</table>
						</div>
					</xsl:if>
				</xsl:if>
				<xsl:if test="position() mod 2 = 0">
					<div class="info-ok">
						<table width="100%" bgcolor="#F5F5F5">
							<xsl:apply-templates select="info"/>
						</table>
					</div>
				</xsl:if>
				<xsl:if test="position() mod 2 != 0">
					<div class="info-ok">
						<table width="100%" bgcolor="#E5E5E5">
							<xsl:apply-templates select="info"/>
						</table>
					</div>
				</xsl:if>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	<!-- **************************** INFO  ***********************************-->
	<xsl:template match="info">
		<tr>
			<td width="30%">
				<font class="infovalue">
					<xsl:value-of select="@name"/>
				</font>
			</td>
			<td width="50%">
				<font class="infoname">
					<xsl:value-of select="@value"/>
				</font>
			</td>
		</tr>
	</xsl:template>
	<!-- **************************** ERROR ***********************************-->
	<xsl:template match="error">
		<div class="error" style="position:relative; top:auto; visibility:visible; left:20px;">
			<table width="100%" bgcolor="#FFBBBB">
				<tr>
					<td width="30%">
						<font class="infovalue">
							<xsl:text>ERROR</xsl:text>
						</font>
					</td>
					<td width="50%">
						<font class="infoname">
							<xsl:value-of select="@value"/>
						</font>
					</td>
				</tr>
			</table>
		</div>
	</xsl:template>
</xsl:stylesheet>
