' ********************************************************************************
' * Save user configuration 
' ********************************************************************************
Option Explicit

'===============================================================================
' Const declaration
'===============================================================================
Const K_FSO_FOR_WRITING = 2
Const OverWriteFiles = TRUE
Const SAVE_DEST_FOLDER = "\a4902save"

'===============================================================================
'Variable declaration
'===============================================================================
Dim WshShell
Dim objFso
dim objFolder

Dim strRegKey
Dim strAppName
Dim strAppPath
Dim strMyDocumentsPath
Dim strApplicationDataPath
Dim strSavePath
Dim strExecCommand
dim objFile
dim strRestoreFileName

' objets creation
Set WshShell = Wscript.CreateObject("Wscript.Shell")
set objFso = CreateObject("Scripting.FileSystemObject")

' Get special folders
strMyDocumentsPath = WshShell.SpecialFolders("MyDocuments")
strApplicationDataPath = WshShell.SpecialFolders("AppData")

' Get Application installation parameters
strRegKey = "HKLM\Software\Alcatel\4902\Install\" 
strAppName = WshShell.regread(strRegKey & "4902Name")
strAppPath = WshShell.regread(strRegKey & "Path")

strApplicationDataPath = strApplicationDataPath & "\" & strAppName
strSavePath = strMyDocumentsPath & SAVE_DEST_FOLDER
'WScript.Echo strApplicationDataPath
'WScript.Echo strSavePath

' create save destination folder
If not(objFso.FolderExists(strSavePath)) Then
	set objFolder = objFso.CreateFolder(strSavePath)
else 
	set objFolder = objFso.GetFolder(strSavePath)
end if

' copy restore script file to save folder
strRestoreFileName = "\restore.vbs"
If objFso.FileExists("." & strRestoreFileName) Then
	objFso.CopyFile "." & strRestoreFileName, strSavePath & "\", OverWriteFiles
end if

' save registry keys
strExecCommand = "REG.exe EXPORT ""HKCU\Software\Alcatel\4902"" """ & strSavePath & "\4902BkUp.reg"""
WshShell.run strExecCommand, 5, true
strExecCommand = "REG.exe EXPORT ""HKCU\Software\Alcatel\Alcatel UASig"" """ & strSavePath & "\UAsigBkUp.reg"""
WshShell.run strExecCommand, 5, true
strExecCommand = "REG.exe EXPORT ""HKCU\Software\Alcatel\TSpi_CSTA"" """ & strSavePath & "\TSpiCstaBkUp.reg"""
WshShell.run strExecCommand, 5, true

' save user profile files 
strSavePath = strSavePath & "\config"
If not(objFso.FolderExists(strSavePath)) Then
	set objFolder = objFso.CreateFolder(strSavePath)
else 
	set objFolder = objFso.GetFolder(strSavePath)
end if
if objFso.FolderExists(strApplicationDataPath) then
	objFso.CopyFile strApplicationDataPath & "\*", strSavePath & "\", OverWriteFiles
	objFso.CopyFolder strApplicationDataPath & "\*", strSavePath & "\", OverWriteFiles
end if

WScript.Echo "Configuration saved in ""MyDocuments" & SAVE_DEST_FOLDER & """ folder."